function Elgoh_New()
	PollItems = {};
	PollVotes = {};
	PollVoting = false;
	PollTexts={};
	PollTitle="Choose:";
	edtPollTitle:SetText("Choose:");
end

function Elgoh_SetItem(itemName, index)
	if (index ~= nil) then
		index = math.floor(index)
		PollItems[index] = itemName
	end

	Elgoh_OrderItems();
	Elgoh_List();
	return true
end

function Elgoh_RemoveItem(self, button)
	for index=1,#PollItems do
		if (PollItems[index] == self:GetText()) then
			frmOfficer:SetHeight(frmOfficer:GetHeight()-30);
			OElgohVote:SetHeight(OElgohVote:GetHeight()-30);
			table.remove(PollItems, index);
			Elgoh_OrderItems();
			return true;
		end
	end
end

function Elgoh_AddItem(item)
	if(#PollItems==5) then 
		Elgoh_Print("Only 5 items may be added");
		edtItem:ClearFocus();
		return false; 
	end
	if(not item) then return false; end
	if(item=="") then return false; end
	for index=0,#PollItems do
		if (PollItems[index] == item) then
			Elgoh_Print("Item already exist at "..index);
			edtItem:ClearFocus();
			return false;
		end
	end
	
	frmOfficer:SetHeight(frmOfficer:GetHeight()+30);
	OElgohVote:SetHeight(OElgohVote:GetHeight()+30);
	edtItem:SetText("");
	table.insert(PollItems, index)
		PollItems[#PollItems+1]=item;
	Elgoh_OrderItems()
	return true
end

function Elgoh_List()
	local index, itemName
	for index, itemName in pairs(PollItems) do
		SendChatMessage(index..": "..itemName, "GUILD");
	end
	SendChatMessage("Whisper me with \"vote <number>\" to vote", "GUILD");
end

function Elgoh_Vote(player, index)
	local indexValid, alreadyVoted

	indexValid = (index ~= nil) and (PollItems[index] ~= nil)
	
	if (not indexValid) then
		return false
	end
	if who==nil then who=UnitName("player"); end
	if(PollVotes[player]==nil) then
		SendChatMessage("Thank you for voting for \""..PollItems[index].."\"!", "WHISPER",GetDefaultLanguage("player"), who);
	else
		SendChatMessage("You've changed your vote to \""..PollItems[index].."\"", "WHISPER",GetDefaultLanguage("player"), who);
	end
	PollVotes[player] = {}
	PollVotes[player]["item"] = index

	local numVotes = 0
	for _, _ in pairs(PollVotes) do
		numVotes = numVotes + 1
	end

	return true
end

function Elgoh_Start()
	if (PollVoting == true) then
		Elgoh_Print("Another vote is already in progress");
		return false
	end
	
	if (#PollItems < 2) then
		Elgoh_Print("You need to add at least 2 items");
		return false
	end
	PollVotes = {};
	PollVoting = true;
	SendChatMessage(edtPollTitle:GetText(), "GUILD");
	Elgoh_List();
	btnElgohStart:SetText("Stop");
end

function Elgoh_Stop()
	PollVoting = false
	
	local stuffToSay = {}
	local results = Elgoh_GetResults()

	if (#results == 0) then
		return
	end
	local row

	SendChatMessage("The results are in!", "GUILD")
	SendChatMessage(edtPollTitle:GetText(), "GUILD");
	for _, row in pairs(results) do
		SendChatMessage(row, "GUILD");
	end
	
	OElgohVote:SetHeight(120);
	frmOfficer:SetHeight(300);
	
	for index, itemName in pairs(PollItems) do
		if(PollTexts[index]~=nil) then
			PollTexts[index]:Hide();
		end
	end
	btnElgohStart:SetText("Start");
	Elgoh_New();
	Elgoh_OrderItems();
end

function Elgoh_GetResults()
	local itemsCount = {}
	local player, playerRow, index
	local totalCount = 0

	if (#PollItems == 0) then
		return {}
	end

	for index, _ in pairs(PollItems) do
		itemsCount[index] = {}
		itemsCount[index]['num']  = 0
		itemsCount[index]['item'] = index
	end

	for player, playerRow in pairs(PollVotes) do
		itemsCount[playerRow['item']]['num'] = itemsCount[playerRow['item']]['num'] + 1
		totalCount = totalCount + 1
	end

	table.sort(itemsCount, CompareResults)

	local resultsTable = {}
	local value
	local position = 1

	if (totalCount == 0) then
		totalCount = 1
	end

	for index, value in pairs(itemsCount) do
		table.insert(resultsTable, position..". "..
			                         PollItems[value['item']]..": ".. value['num'].." ("..math.floor(0.5 + 100 * value['num'] / totalCount).."%)")
		position = position + 1
	end

	return resultsTable
end

function CompareResults(rowA, rowB)
	return rowA['num'] > rowB['num']
end

function Elgoh_OrderItems()
	local index, itemName
	local indexes, newItemList
	newItemList = {}
	indexes = {}
	
	for index, _ in pairs(PollItems) do
		table.insert(indexes, index)
	end
	
	table.sort(indexes)
	
	for _, index in pairs(indexes) do
		newItemList[index] = PollItems[index]
	end

	PollItems = newItemList
	for index=0, 5 do
		if(PollTexts[index]==nil) then
			PollTexts[index]=CreateFrame("Button",nil,OElgohVote,"UIPanelButtonTemplate")
			PollTexts[index]:RegisterForClicks("AnyUp");
			PollTexts[index]:SetScript("OnClick", Elgoh_RemoveItem);
			PollTexts[index]:SetPoint("TOP", "OElgohVote", "TOP", 0, -(55+(index*25)));
			PollTexts[index]:SetWidth(150)
			PollTexts[index]:SetHeight(20)
			PollTexts[index]:Hide();
		end
		if(PollItems[index]) then
			PollTexts[index]:SetText(PollItems[index]);
			PollTexts[index]:Show();
		else
			PollTexts[index]:Hide();
		end
	end
end

function Elgoh_PollEvent(event, ...)
	if (event == "CHAT_MSG_WHISPER") then
	if(PollVoting~=true) then return; end
		msg,who=...;
		msg=string.lower(msg);
		local voting = string.find(msg, "vote")
		if(voting ~= nil) then
			voting=string.sub(msg, voting+6)
			voting=tonumber(voting);
			Elgoh_Vote(who,voting);
			return
		end
		
		local DKP = string.find(msg, "!dkp")
		if(DKP~=nil) then
			Elgoh_DKPWhisper(who)
		end
	end
end